# GetRemoteAddr
# Returns the IP address of the remote user logged on the web page
sub GetRemoteAddr {
  return $ENV{'REMOTE_ADDR'};
}

# CvrtFTPSite(site-dir)
# Converts an FTP site to proper spacing and display
sub CvrtFTPSite {
   $usite = $_[0];
   if (($usite ne "/") && ($usite ne "")) {
      if (substr($usite,0,1) ne "/") {
         $disp_site = "";
         $http_site = "";
         $ftp_site  = "";
      } else {
         $disp_site = "/";
         $http_site = "/";

         @list = split("/", $usite);
         while (@list) {
            $disp_site_word = "";
            $http_site_word = "";
            $word = pop(@list);
            if ($word =~ / /) {
               $len = length($word);

               while ($len > 0) {
                  $sp = 0;
                  $char = chop($word);

                  while ($char eq " ") {
                     $sp++;

                     $len--;
                     $char = chop($word);
                  }

                  if ($sp != 0) {
                     $disp_site_word = "<$sp sp>".$disp_site_word;
                     while ($sp > 0) {
                        $http_site_word = "%20".$http_site_word;
                        $sp--;
                     }
                     $sp = 0;
                  }

                  $hchar = $char;
                  if ($char eq ";") { $hchar = "%3B"; }
                  if ($char eq "/") { $hchar = "%2F"; }
                  if ($char eq "?") { $hchar = "%3F"; }
                  if ($char eq ":") { $hchar = "%3A"; }
                  if ($char eq "@") { $hchar = "%40"; }
                  if ($char eq "=") { $hchar = "%3D"; }
                  if ($char eq "&") { $hchar = "%26"; }
                  if ($char eq "<") { $hchar = "%3C"; }
                  if ($char eq ">") { $hchar = "%3E"; }
                  if ($char eq "\"") { $hchar = "%22"; }
                  if ($char eq "#") { $hchar = "%23"; }
                  if ($char eq "%") { $hchar = "%25"; }
                  if ($char eq "{") { $hchar = "%7B"; }
                  if ($char eq "}") { $hchar = "%7D"; }
                  if ($char eq "|") { $hchar = "%7C"; }
                  if ($char eq "\\") { $hchar = "%5C"; }
                  if ($char eq "^") { $hchar = "%5E"; }
                  if ($char eq "~") { $hchar = "%7E"; }
                  if ($char eq "[") { $hchar = "%5B"; }
                  if ($char eq "]") { $hchar = "%5D"; }
                  if ($char eq "`") { $hchar = "%60"; }

                  $disp_site_word = $char.$disp_site_word;
                  $http_site_word = $hchar.$http_site_word;

                  $len--;
               }

               $disp_site_word = "/".$disp_site_word;
               $http_site_word = "/".$http_site_word;
               $disp_site = $disp_site_word.$disp_site;
               $http_site = $http_site_word.$http_site;

            } else {
               $disp_site = "/".$word.$disp_site;
               $http_site = "/".$word.$http_site;
            }
         }

         $disp_site =~ s/\///;
         $http_site =~ s/\///;
         $ftp_site = $usite;

         $tmpstr = $ftp_site;
         if (chop($tmpstr) ne "/") {
            $ftp_site = $ftp_site."/";
         }
      }
   } else {
      $disp_site = "/";
      $http_site = "/";
      $ftp_site = "/";
   }

   return ($disp_site, $http_site, $ftp_site);
}

1; #return true 
