#!/usr/local/bin/perl

# $Header: /cys/people/brenner/http/docs/web/RCS/simple-form.cgi,v 1.4 1996/03/29 22:07:56 brenner Exp $
# Copyright (C) 1994 Steven E. Brenner
# This is a small demonstration script to demonstrate the use of 
# the cgi-lib.cgi library

require "cgi-lib.cgi";
require "tzr-lib.cgi";

MAIN:
{
   $return_path = "w_display.cgi";
   $site_list_dir = ".";

   # Read in all the variables set by the form
   &ReadParse(*input);

   #Setup Mail File Handle

   # Print the header
   print &PrintHeader;

   $remoteip = &GetRemoteAddr;

   $banned = 0;
   open(BANNED, "<$site_list_dir/banned.lst");
   while (<BANNED>) {
      chop;
      if ($remoteip eq $_) {
         $banned = 1;
      }
   }
   close(BANNED);

if ($banned == 0) {
   # Do some processing, and print some output
   $address     = $input{'address'};
   $directory   = $input{'directory'};
   $login       = $input{'login'};
   $password    = $input{'password'};
   $portnum     = $input{'portnum'};
   $description = $input{'description'};

      $usite = $directory;

      $invalid = 0;

      if ($address eq "") {
         $errmsg = "FTP address can not be blank.";
         $invalid = 1;
      }

      if ($address =~ /[^\-\.0-9A-Za-z]/) {
         $errmsg = "FTP address is using invalid characters.";
         $invalid = 1;
      }

      $tmpstr = $address;
      $tmpstr =~ s/\.//g;
      ($t1, $t2, $t3) = split("", $tmpstr);
      if (($t1 eq "") || ($t2 eq "") || ($t3 eq "")) {
         $errmsg = "Sorry, FTP address must be in proper form.";
         $invalid = 1;
      }

      if (($login ne "") && ($password eq "")) {
         $errmsg = "You can not have a blank password and something for login.";
         $invalid = 1;
      }

      if (($login eq "") && ($password ne "")) {
         $errmsg = "You can not have a blank login and something for password.";
      }

      if ($portnum eq "21") {
         $errmsg = "Do not enter the default port number 21 for FTP. Leave port field blank.";
         $invalid = 1;
      }

      if ($portnum =~ /\D/) {
         $errmsg = "The port number can not have non-numeric characters";
         $invalid = 1;
      }

      if ($invalid == 0) {
         @siteinfo = &CvrtFTPSite($usite);

         $disp_site = $siteinfo[0];
         $http_site = $siteinfo[1];
         $ftp_site  = $siteinfo[2];

         open(DATE, "date +'%D %T'|");
            while(<DATE>) {
            chop;
            ($date, $time) = split(" ");
         }

         if (-f "$site_list_dir/locked.tmp") {
            $locked = 1;
         } else {
            open(LFILE, ">$site_list_dir/locked.tmp");
            print LFILE "System Currently Locked, Please Try Again in a Minute.\n";
            close(LFILE);
            $locked = 0;
         }
         while ($locked == 1) {
           if (-f "$site_list_dir/locked.tmp") {
               $locked = 1;
            } else {
               open(LFILE, ">$site_list_dir/locked.tmp");
               print LFILE "System Currently Locked, Please Try Again in a Minute.\n";
               close(LFILE);
               $locked = 0;
            }
         }

         open(FTP_FILE, ">>$site_list_dir/ftp_list.dat");
         $description =~ s/\s+/ /g;
         $ipsubmit = &GetRemoteAddr;
         $data = join("", $date, $time, $ipsubmit, $address, $ftp_site, $http_site, $disp_site, $login, $password, $portnum, $description);
         print FTP_FILE "$data\n";

         close(FTP_FILE);

         system("rm $site_list_dir/locked.tmp");

      } else {
         print "$errmsg<BR>\n";
         print "<P><A href=\"$site_list_path/$return_path\">Return to Previous Menu</a></p>";
      }
} else {
   print "Sorry, you have been banned from this site! Try again in a few million years you fuck!<BR>";
}

   # Close the document cleanly.
   print &HtmlBot;
}
